> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Retrieve a product

GET https://rest.test.zuora.com/object-query/products/{key}

Retrieve the details of a specific Product object.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/object-query/object-queries/query-product-by-key

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `key` (string, required) — ID or SKU of a product.

### Query parameters

- `pageSize` (integer, optional, default: 10) — The maximum number of results to return in a single page. If the specified `pageSize` is less than 1 or greater than 99, Zuora will return a 400 error.
- `cursor` (string, optional) — A cursor for use in pagination. A cursor defines the starting place in a list. For instance, if you make a list request and receive 100 objects, ending with `next_page=W3sib3JkZXJ=`, your subsequent call can include `cursor=W3sib3JkZXJ=` in order to fetch the next page of the list.
- `sort[]` (list of string, optional) — A case-insensitive query parameter that specifies the sort order of the list, which can be either ascending (e.g. `accountnumber.ASC`) or descending (e.g. `accountnumber.DESC`). You cannot sort on properties in arrays. If the array-type properties are specified for the `sort[]` parameter, they are ignored.
- `expand[]` (list of enum, optional) — Allows you to expand responses by including related object information in a single call.
  - Allowed values: `productrateplans`, `productrateplans.productrateplancharges`, `productrateplans.productrateplancharges.productrateplanchargetiers`
- `filter[]` (list of string, optional) — A case-insensitive filter on the list.
- `fields[]` (list of string, optional) — A case-insensitive query parameter that allows you to specify which fields are returned in the response.
- `includeNullFields` (boolean, optional, default: false) — Specifies whether to include fields with the `null` value in the response. - If set to `true`, all fields will be returned in the response, including those with the `null` value. - If set to `false`, only fields with non-null values will be returned.

### Headers

- `Idempotency-Key` (string, optional) — Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

## Response

### 200

OK

- `id` (string, optional) — The unique identifier of the product.
- `createdById` (string, optional) — The unique identifier of the user who created the product.
- `createdDate` (datetime, optional) — The date and time when the product was created.
- `updatedById` (string, optional) — The unique identifier of the user who last updated the product.
- `updatedDate` (datetime, optional) — The date and time when the product was last updated.
- `allowFeatureChanges` (boolean, optional, default: false) — Controls whether to allow your users to add or remove features while creating or amending a subscription.
- `description` (string, optional) — A description of the product.
- `name` (string, optional) — The name of the product. This information is displayed in the product catalog pages in the web-based UI.
- `effectiveEndDate` (date, optional) — The date when the product expires and can't be subscribed to anymore, in the `yyyy-mm-dd` format.
- `effectiveStartDate` (date, optional) — The date when the product becomes available and can be subscribed to, in the `yyyy-mm-dd` format.
- `sKU` (string, optional) — The unique SKU for the product.
- `productNumber` (string, optional) — The product number of the product.
- `category` (enum, optional) — Category of the product. Used by Zuora Quotes Guided Product Selector.
  - Allowed values: `Base Products`, `Add On Services`, `Miscellaneous Products`
- `productRatePlans` (list of NestedProductRatePlanOnExpand, optional)

## Errors

### 500 Internal Server Error

Internal server error

- `reasons` (list of CommonOqErrorResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (any, optional) — The unique identifier of the request.

### 400 Client Request Error

Invalid input

- `reasons` (list of CommonOqErrorResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (any, optional) — The unique identifier of the request.

## Types

### NestedProductRatePlanOnExpand

- `id` (string, optional) — The unique identifier of the product rate plan.
- `createdById` (string, optional) — The unique identifier of the user who created the product rate plan.
- `createdDate` (datetime, optional) — The date and time when the product rate plan was created.
- `updatedById` (string, optional) — The unique identifier of the user who last updated the product rate plan.
- `updatedDate` (datetime, optional) — The date and time when the product rate plan was last updated.
- `productId` (string, optional) — The unique identifier of the product to which this product rate plan belongs.
- `name` (string, optional) — The name of the product rate plan.
- `description` (string, optional) — A description of the product rate plan.
- `effectiveStartDate` (date, optional) — First date the rate plan is active (i.e., available to be subscribed to), as `yyyy-mm-dd`. Before this date, the status is `NotStarted`.
- `effectiveEndDate` (date, optional) — Final date the rate plan is active, as `yyyy-mm-dd`. After this date, the rate plan status is `Expired`.
- `grade` (integer, optional) — The grade of the product rate plan. **Note**: This field is in the **Early Adopter** phase. We are actively soliciting feedback from a small set of early adopters before releasing it as generally available. If you want to join this early adopter program, submit a request at [Zuora Global Support](http://support.zuora.com/).
- `productRatePlanNumber` (string, optional) — The natural key of the product rate plan.
- `product` (NestedProductRatePlanOnExpandProduct, optional) — The product associated with the product rate plan.
- `productRatePlanCharges` (list of NestedProductRatePlanOnExpandProductRatePlanChargesItems, optional) — The product rate plan charges on the product rate plan.

### CommonOqErrorResponseReasonsItems

- `code` (integer, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### NestedProductRatePlanOnExpandProduct

The product associated with the product rate plan.

### NestedProductRatePlanOnExpandProductRatePlanChargesItems

## Examples

**Response**

```json
{
  "id": "8ad08ea194da7ba00194df52a41f04c6",
  "createdById": "2c92c0f972a852360172bbe22ac551b6",
  "createdDate": "2025-02-06T23:32:02-08:00",
  "updatedById": "2c92c0f972a852360172bbe22ac551b6",
  "updatedDate": "2025-02-06T23:32:02-08:00",
  "allowFeatureChanges": false,
  "description": "Cloud Service provided by ACME Corp.",
  "name": "Cloud Service",
  "effectiveEndDate": "2032-10-20",
  "effectiveStartDate": "2022-10-20",
  "sKU": "SKU-001",
  "productNumber": "PC-00000027"
}
```

**SDK Code**

```python Object Queries_queryProductByKey_example
import requests

url = "https://rest.test.zuora.com/object-query/products/key"

querystring = {"fields[]":"[\"id,createddate\"]"}

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript Object Queries_queryProductByKey_example
const url = 'https://rest.test.zuora.com/object-query/products/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Object Queries_queryProductByKey_example
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/object-query/products/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Object Queries_queryProductByKey_example
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/object-query/products/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java Object Queries_queryProductByKey_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/object-query/products/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php Object Queries_queryProductByKey_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/object-query/products/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp Object Queries_queryProductByKey_example
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/object-query/products/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift Object Queries_queryProductByKey_example
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/object-query/products/key?fields%5B%5D=%5B%22id%2Ccreateddate%22%5D")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```